xref: /freebsd/usr.sbin/bsdinstall/scripts/zfsboot (revision a5ff72cb0e51a7675d4e2b5810a2b6dad5b91960)
1#!/bin/sh
2#-
3# Copyright (c) 2013-2015 Allan Jude
4# Copyright (c) 2013-2015 Devin Teske
5# All rights reserved.
6#
7# Redistribution and use in source and binary forms, with or without
8# modification, are permitted provided that the following conditions
9# are met:
10# 1. Redistributions of source code must retain the above copyright
11#    notice, this list of conditions and the following disclaimer.
12# 2. Redistributions in binary form must reproduce the above copyright
13#    notice, this list of conditions and the following disclaimer in the
14#    documentation and/or other materials provided with the distribution.
15#
16# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
17# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
19# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
20# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
21# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
22# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
23# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
24# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
25# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
26# SUCH DAMAGE.
27#
28# $FreeBSD$
29#
30############################################################ INCLUDES
31
32BSDCFG_SHARE="/usr/share/bsdconfig"
33. $BSDCFG_SHARE/common.subr || exit 1
34f_dprintf "%s: loading includes..." "$0"
35f_include $BSDCFG_SHARE/device.subr
36f_include $BSDCFG_SHARE/dialog.subr
37f_include $BSDCFG_SHARE/password/password.subr
38f_include $BSDCFG_SHARE/variable.subr
39
40############################################################ CONFIGURATION
41
42#
43# Default name of the boot-pool
44#
45: ${ZFSBOOT_POOL_NAME:=zroot}
46
47#
48# Default options to use when creating zroot pool
49#
50: ${ZFSBOOT_POOL_CREATE_OPTIONS:=-O compress=lz4 -O atime=off}
51
52#
53# Default name for the boot environment parent dataset
54#
55: ${ZFSBOOT_BEROOT_NAME:=ROOT}
56
57#
58# Default name for the primany boot environment
59#
60: ${ZFSBOOT_BOOTFS_NAME:=default}
61
62#
63# Default Virtual Device (vdev) type to create
64#
65: ${ZFSBOOT_VDEV_TYPE:=stripe}
66
67#
68# Should we use sysctl(8) vfs.zfs.min_auto_ashift=12 to force 4K sectors?
69#
70: ${ZFSBOOT_FORCE_4K_SECTORS:=1}
71
72#
73# Should we use geli(8) to encrypt the drives?
74# NB: Automatically enables ZFSBOOT_BOOT_POOL
75#
76: ${ZFSBOOT_GELI_ENCRYPTION=}
77
78#
79# Default path to the geli(8) keyfile used in drive encryption
80#
81: ${ZFSBOOT_GELI_KEY_FILE:=/boot/encryption.key}
82
83#
84# Create a separate boot pool?
85# NB: Automatically set when using geli(8) or MBR
86#
87: ${ZFSBOOT_BOOT_POOL=}
88
89#
90# Options to use when creating separate boot pool (if any)
91#
92: ${ZFSBOOT_BOOT_POOL_CREATE_OPTIONS:=}
93
94#
95# Default name for boot pool when enabled (e.g., geli(8) or MBR)
96#
97: ${ZFSBOOT_BOOT_POOL_NAME:=bootpool}
98
99#
100# Default size for boot pool when enabled (e.g., geli(8) or MBR)
101#
102: ${ZFSBOOT_BOOT_POOL_SIZE:=2g}
103
104#
105# Default disks to use (always empty unless being scripted)
106#
107: ${ZFSBOOT_DISKS:=}
108
109#
110# Default partitioning scheme to use on disks
111#
112: ${ZFSBOOT_PARTITION_SCHEME:=}
113
114#
115# Default boot type to use on disks
116#
117: ${ZFSBOOT_BOOT_TYPE:=}
118
119#
120# How much swap to put on each block device in the boot zpool
121# NOTE: Value passed to gpart(8); which supports SI unit suffixes.
122#
123: ${ZFSBOOT_SWAP_SIZE:=2g}
124
125#
126# Should we use geli(8) to encrypt the swap?
127#
128: ${ZFSBOOT_SWAP_ENCRYPTION=}
129
130#
131# Should we use gmirror(8) to mirror the swap?
132#
133: ${ZFSBOOT_SWAP_MIRROR=}
134
135#
136# Default ZFS datasets for root zpool
137#
138# NOTE: Requires /tmp, /var/tmp, /$ZFSBOOT_BOOTFS_NAME/$ZFSBOOT_BOOTFS_NAME
139# NOTE: Anything after pound/hash character [#] is ignored as a comment.
140#
141f_isset ZFSBOOT_DATASETS || ZFSBOOT_DATASETS="
142	# DATASET	OPTIONS (comma or space separated; or both)
143
144	# Boot Environment [BE] root and default boot dataset
145	/$ZFSBOOT_BEROOT_NAME				mountpoint=none
146	/$ZFSBOOT_BEROOT_NAME/$ZFSBOOT_BOOTFS_NAME	mountpoint=/
147
148	# Compress /tmp, allow exec but not setuid
149	/tmp		mountpoint=/tmp,exec=on,setuid=off
150
151	# Don't mount /usr so that 'base' files go to the BEROOT
152	/usr		mountpoint=/usr,canmount=off
153
154	# Home directories separated so they are common to all BEs
155	/usr/home	# NB: /home is a symlink to /usr/home
156
157	# Ports tree
158	/usr/ports	setuid=off
159
160	# Source tree (compressed)
161	/usr/src
162
163	# Create /var and friends
164	/var		mountpoint=/var,canmount=off
165	/var/audit	exec=off,setuid=off
166	/var/crash	exec=off,setuid=off
167	/var/log	exec=off,setuid=off
168	/var/mail	atime=on
169	/var/tmp	setuid=off
170" # END-QUOTE
171
172#
173# If interactive and the user has not explicitly chosen a vdev type or disks,
174# make the user confirm scripted/default choices when proceeding to install.
175#
176: ${ZFSBOOT_CONFIRM_LAYOUT:=1}
177
178############################################################ GLOBALS
179
180#
181# Format of a line in printf(1) syntax to add to fstab(5)
182#
183FSTAB_FMT="%s\t\t%s\t%s\t%s\t\t%s\t%s\n"
184
185#
186# Command strings for various tasks
187#
188CHMOD_MODE='chmod %s "%s"'
189DD_WITH_OPTIONS='dd if="%s" of="%s" %s'
190ECHO_APPEND='echo "%s" >> "%s"'
191GELI_ATTACH='geli attach -j - -k "%s" "%s"'
192GELI_DETACH_F='geli detach -f "%s"'
193GELI_PASSWORD_INIT='geli init -b -B "%s" -e %s -J - -K "%s" -l 256 -s 4096 "%s"'
194GPART_ADD_ALIGN='gpart add %s -t %s "%s"'
195GPART_ADD_ALIGN_INDEX='gpart add %s -i %s -t %s "%s"'
196GPART_ADD_ALIGN_INDEX_WITH_SIZE='gpart add %s -i %s -t %s -s %s "%s"'
197GPART_ADD_ALIGN_LABEL='gpart add %s -l %s -t %s "%s"'
198GPART_ADD_ALIGN_LABEL_WITH_SIZE='gpart add %s -l %s -t %s -s %s "%s"'
199GPART_BOOTCODE='gpart bootcode -b "%s" "%s"'
200GPART_BOOTCODE_PART='gpart bootcode -b "%s" -p "%s" -i %s "%s"'
201GPART_BOOTCODE_PARTONLY='gpart bootcode -p "%s" -i %s "%s"'
202GPART_CREATE='gpart create -s %s "%s"'
203GPART_DESTROY_F='gpart destroy -F "%s"'
204GPART_SET_ACTIVE='gpart set -a active -i %s "%s"'
205GPART_SET_LENOVOFIX='gpart set -a lenovofix "%s"'
206GPART_SET_PMBR_ACTIVE='gpart set -a active "%s"'
207GRAID_DELETE='graid delete "%s"'
208LN_SF='ln -sf "%s" "%s"'
209MKDIR_P='mkdir -p "%s"'
210MOUNT_TYPE='mount -t %s "%s" "%s"'
211PRINTF_CONF="printf '%s=\"%%s\"\\\n' %s >> \"%s\""
212PRINTF_FSTAB='printf "$FSTAB_FMT" "%s" "%s" "%s" "%s" "%s" "%s" >> "%s"'
213SHELL_TRUNCATE=':> "%s"'
214SWAP_GMIRROR_LABEL='gmirror label swap %s'
215SYSCTL_ZFS_MIN_ASHIFT_12='sysctl vfs.zfs.min_auto_ashift=12'
216UMOUNT='umount "%s"'
217ZFS_CREATE_WITH_OPTIONS='zfs create %s "%s"'
218ZFS_SET='zfs set "%s" "%s"'
219ZFS_UNMOUNT='zfs unmount "%s"'
220ZPOOL_CREATE_WITH_OPTIONS='zpool create %s "%s" %s %s'
221ZPOOL_DESTROY='zpool destroy "%s"'
222ZPOOL_EXPORT='zpool export "%s"'
223ZPOOL_IMPORT_WITH_OPTIONS='zpool import %s "%s"'
224ZPOOL_LABELCLEAR_F='zpool labelclear -f "%s"'
225ZPOOL_SET='zpool set %s "%s"'
226
227#
228# Strings that should be moved to an i18n file and loaded with f_include_lang()
229#
230hline_alnum_arrows_punc_tab_enter="Use alnum, arrows, punctuation, TAB or ENTER"
231hline_arrows_space_tab_enter="Use arrows, SPACE, TAB or ENTER"
232hline_arrows_tab_enter="Press arrows, TAB or ENTER"
233msg_an_unknown_error_occurred="An unknown error occurred"
234msg_back="Back"
235msg_cancel="Cancel"
236msg_change_selection="Change Selection"
237msg_configure_options="Configure Options:"
238msg_detailed_disk_info="gpart(8) show %s:\n%s\n\ncamcontrol(8) inquiry %s:\n%s\n\n\ncamcontrol(8) identify %s:\n%s\n"
239msg_disk_info="Disk Info"
240msg_disk_info_help="Get detailed information on disk device(s)"
241msg_disk_singular="disk"
242msg_disk_plural="disks"
243msg_encrypt_disks="Encrypt Disks?"
244msg_encrypt_disks_help="Use geli(8) to encrypt all data partitions"
245msg_error="Error"
246msg_force_4k_sectors="Force 4K Sectors?"
247msg_force_4k_sectors_help="Align partitions to 4K sector boundries and set vfs.zfs.min_auto_ashift=12"
248msg_freebsd_installer="FreeBSD Installer"
249msg_geli_password="Enter a strong passphrase, used to protect your encryption keys. You will be required to enter this passphrase each time the system is booted"
250msg_geli_setup="Initializing encryption on selected disks,\n this will take several seconds per disk"
251msg_install="Install"
252msg_install_desc="Proceed with Installation"
253msg_install_help="Create ZFS boot pool with displayed options"
254msg_invalid_boot_pool_size="Invalid boot pool size \`%s'"
255msg_invalid_disk_argument="Invalid disk argument \`%s'"
256msg_invalid_index_argument="Invalid index argument \`%s'"
257msg_invalid_swap_size="Invalid swap size \`%s'"
258msg_invalid_virtual_device_type="Invalid Virtual Device type \`%s'"
259msg_last_chance_are_you_sure="Last Chance! Are you sure you want to destroy\nthe current contents of the following disks:\n\n   %s"
260msg_last_chance_are_you_sure_color='\\ZrLast Chance!\\ZR Are you \\Z1sure\\Zn you want to \\Zr\\Z1destroy\\Zn\nthe current contents of the following disks:\n\n   %s'
261msg_mirror_desc="Mirror - n-Way Mirroring"
262msg_mirror_help="[2+ Disks] Mirroring provides the best performance, but the least storage"
263msg_missing_disk_arguments="missing disk arguments"
264msg_missing_one_or_more_scripted_disks="Missing one or more scripted disks!"
265msg_no="NO"
266msg_no_disks_present_to_configure="No disk(s) present to configure"
267msg_no_disks_selected="No disks selected."
268msg_not_enough_disks_selected="Not enough disks selected. (%u < %u minimum)"
269msg_null_disk_argument="NULL disk argument"
270msg_null_index_argument="NULL index argument"
271msg_null_poolname="NULL poolname"
272msg_ok="OK"
273msg_partition_scheme="Partition Scheme"
274msg_partition_scheme_help="Select partitioning scheme. GPT is recommended."
275msg_please_enter_a_name_for_your_zpool="Please enter a name for your zpool:"
276msg_please_enter_amount_of_swap_space="Please enter amount of swap space (SI-Unit suffixes\nrecommended; e.g., \`2g' for 2 Gigabytes):"
277msg_please_select_one_or_more_disks="Please select one or more disks to create a zpool:"
278msg_pool_name="Pool Name"
279msg_pool_name_cannot_be_empty="Pool name cannot be empty."
280msg_pool_name_help="Customize the name of the zpool to be created (Required)"
281msg_pool_type_disks="Pool Type/Disks:"
282msg_pool_type_disks_help="Choose type of ZFS Virtual Device and disks to use (Required)"
283msg_processing_selection="Processing selection..."
284msg_raidz1_desc="RAID-Z1 - Single Redundant RAID"
285msg_raidz1_help="[3+ Disks] Withstand failure of 1 disk. Recommended for: 3, 5 or 9 disks"
286msg_raidz2_desc="RAID-Z2 - Double Redundant RAID"
287msg_raidz2_help="[4+ Disks] Withstand failure of 2 disks. Recommended for: 4, 6 or 10 disks"
288msg_raidz3_desc="RAID-Z3 - Triple Redundant RAID"
289msg_raidz3_help="[5+ Disks] Withstand failure of 3 disks. Recommended for: 5, 7 or 11 disks"
290msg_rescan_devices="Rescan Devices"
291msg_rescan_devices_help="Scan for device changes"
292msg_select="Select"
293msg_select_a_disk_device="Select a disk device"
294msg_select_virtual_device_type="Select Virtual Device type:"
295msg_stripe_desc="Stripe - No Redundancy"
296msg_stripe_help="[1+ Disks] Striping provides maximum storage but no redundancy"
297msg_swap_encrypt="Encrypt Swap?"
298msg_swap_encrypt_help="Encrypt swap partitions with temporary keys, discarded on reboot"
299msg_swap_invalid="The selected swap size (%s) is invalid. Enter a number optionally followed by units. Example: 2G"
300msg_swap_mirror="Mirror Swap?"
301msg_swap_mirror_help="Mirror swap partitions for redundancy, breaks crash dumps"
302msg_swap_size="Swap Size"
303msg_swap_size_help="Customize how much swap space is allocated to each selected disk"
304msg_swap_toosmall="The selected swap size (%s) is to small. Please enter a value greater than 100MB or enter 0 for no swap"
305msg_these_disks_are_too_small="These disks are smaller than the amount of requested\nswap (%s) and/or geli(8) (%s) partitions, which would\ntake 100%% or more of each of the following selected disks:\n\n  %s\n\nRecommend changing partition size(s) and/or selecting a\ndifferent set of disks."
306msg_unable_to_get_disk_capacity="Unable to get disk capacity of \`%s'"
307msg_unsupported_partition_scheme="%s is an unsupported partition scheme"
308msg_user_cancelled="User Cancelled."
309msg_yes="YES"
310msg_zfs_configuration="ZFS Configuration"
311
312############################################################ FUNCTIONS
313
314# dialog_menu_main
315#
316# Display the dialog(1)-based application main menu.
317#
318dialog_menu_main()
319{
320	local title="$DIALOG_TITLE"
321	local btitle="$DIALOG_BACKTITLE"
322	local prompt="$msg_configure_options"
323	local force4k="$msg_no"
324	local usegeli="$msg_no"
325	local swapgeli="$msg_no"
326	local swapmirror="$msg_no"
327	[ "$ZFSBOOT_FORCE_4K_SECTORS" ] && force4k="$msg_yes"
328	[ "$ZFSBOOT_GELI_ENCRYPTION" ] && usegeli="$msg_yes"
329	[ "$ZFSBOOT_SWAP_ENCRYPTION" ] && swapgeli="$msg_yes"
330	[ "$ZFSBOOT_SWAP_MIRROR" ] && swapmirror="$msg_yes"
331	local disks n disks_grammar
332	f_count n $ZFSBOOT_DISKS
333	{ [ $n -eq 1 ] && disks_grammar=$msg_disk_singular; } ||
334		disks_grammar=$msg_disk_plural # grammar
335	local menu_list="
336		'>>> $msg_install'      '$msg_install_desc'
337		                        '$msg_install_help'
338		'T $msg_pool_type_disks'
339		                        '$ZFSBOOT_VDEV_TYPE: $n $disks_grammar'
340		                        '$msg_pool_type_disks_help'
341		'- $msg_rescan_devices' '*'
342		                        '$msg_rescan_devices_help'
343		'- $msg_disk_info'      '*'
344		                        '$msg_disk_info_help'
345		'N $msg_pool_name'      '$ZFSBOOT_POOL_NAME'
346		                        '$msg_pool_name_help'
347		'4 $msg_force_4k_sectors'
348		                        '$force4k'
349		                        '$msg_force_4k_sectors_help'
350		'E $msg_encrypt_disks'  '$usegeli'
351		                        '$msg_encrypt_disks_help'
352		'P $msg_partition_scheme'
353		                        '$ZFSBOOT_PARTITION_SCHEME ($ZFSBOOT_BOOT_TYPE)'
354		                        '$msg_partition_scheme_help'
355		'S $msg_swap_size'      '$ZFSBOOT_SWAP_SIZE'
356		                        '$msg_swap_size_help'
357		'M $msg_swap_mirror'    '$swapmirror'
358		                        '$msg_swap_mirror_help'
359		'W $msg_swap_encrypt'   '$swapgeli'
360		                        '$msg_swap_encrypt_help'
361	" # END-QUOTE
362	local defaultitem= # Calculated below
363	local hline="$hline_alnum_arrows_punc_tab_enter"
364
365	local height width rows
366	eval f_dialog_menu_with_help_size height width rows \
367		\"\$title\" \"\$btitle\" \"\$prompt\" \"\$hline\" $menu_list
368
369	# Obtain default-item from previously stored selection
370	f_dialog_default_fetch defaultitem
371
372	local menu_choice
373	menu_choice=$( eval $DIALOG \
374		--title \"\$title\"              \
375		--backtitle \"\$btitle\"         \
376		--hline \"\$hline\"              \
377		--item-help                      \
378		--ok-label \"\$msg_select\"      \
379		--cancel-label \"\$msg_cancel\"  \
380		--default-item \"\$defaultitem\" \
381		--menu \"\$prompt\"              \
382		$height $width $rows             \
383		$menu_list                       \
384		2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
385	)
386	local retval=$?
387	f_dialog_data_sanitize menu_choice
388	f_dialog_menutag_store "$menu_choice"
389
390	# Only update default-item on success
391	[ $retval -eq $DIALOG_OK ] && f_dialog_default_store "$menu_choice"
392
393	return $retval
394}
395
396# dialog_last_chance $disks ...
397#
398# Display a list of the disks that the user is about to destroy. The default
399# action is to return error status unless the user explicitly (non-default)
400# selects "Yes" from the noyes dialog.
401#
402dialog_last_chance()
403{
404	local title="$DIALOG_TITLE"
405	local btitle="$DIALOG_BACKTITLE"
406	local prompt # Calculated below
407	local hline="$hline_arrows_tab_enter"
408
409	local height=8 width=50 prefix="   "
410	local plen=${#prefix} list= line=
411	local max_width=$(( $width - 3 - $plen ))
412
413	local yes no defaultno extra_args format
414	if [ "$USE_XDIALOG" ]; then
415		yes=ok no=cancel defaultno=default-no
416		extra_args="--wrap --left"
417		format="$msg_last_chance_are_you_sure"
418	else
419		yes=yes no=no defaultno=defaultno
420		extra_args="--colors --cr-wrap"
421		format="$msg_last_chance_are_you_sure_color"
422	fi
423
424	local disk line_width
425	for disk in $*; do
426		if [ "$line" ]; then
427			line_width=${#line}
428		else
429			line_width=$plen
430		fi
431		line_width=$(( $line_width + 1 + ${#disk} ))
432		# Add newline before disk if it would exceed max_width
433		if [ $line_width -gt $max_width ]; then
434			list="$list$line\n"
435			line="$prefix"
436			height=$(( $height + 1 ))
437		fi
438		# Add the disk to the list
439		line="$line $disk"
440	done
441	# Append the left-overs
442	if [ "${line#$prefix}" ]; then
443		list="$list$line"
444		height=$(( $height + 1 ))
445	fi
446
447	# Add height for Xdialog(1)
448	[ "$USE_XDIALOG" ] && height=$(( $height + $height / 5 + 3 ))
449
450	prompt=$( printf "$format" "$list" )
451	f_dprintf "%s: Last Chance!" "$0"
452	$DIALOG \
453		--title "$title"        \
454		--backtitle "$btitle"   \
455		--hline "$hline"        \
456		--$defaultno            \
457		--$yes-label "$msg_yes" \
458		--$no-label "$msg_no"   \
459		$extra_args             \
460		--yesno "$prompt" $height $width
461}
462
463# dialog_menu_layout
464#
465# Configure Virtual Device type and disks to use for the ZFS boot pool. User
466# must select enough disks to satisfy the chosen vdev type.
467#
468dialog_menu_layout()
469{
470	local funcname=dialog_menu_layout
471	local title="$DIALOG_TITLE"
472	local btitle="$DIALOG_BACKTITLE"
473	local vdev_prompt="$msg_select_virtual_device_type"
474	local disk_prompt="$msg_please_select_one_or_more_disks"
475	local vdev_menu_list="
476		'stripe' '$msg_stripe_desc' '$msg_stripe_help'
477		'mirror' '$msg_mirror_desc' '$msg_mirror_help'
478		'raidz1' '$msg_raidz1_desc' '$msg_raidz1_help'
479		'raidz2' '$msg_raidz2_desc' '$msg_raidz2_help'
480		'raidz3' '$msg_raidz3_desc' '$msg_raidz3_help'
481	" # END-QUOTE
482	local disk_check_list= # Calculated below
483	local vdev_hline="$hline_arrows_tab_enter"
484	local disk_hline="$hline_arrows_space_tab_enter"
485
486	# Warn the user if vdev type is not valid
487	case "$ZFSBOOT_VDEV_TYPE" in
488	stripe|mirror|raidz1|raidz2|raidz3) : known good ;;
489	*)
490		f_dprintf "%s: Invalid virtual device type \`%s'" \
491			  $funcname "$ZFSBOOT_VDEV_TYPE"
492		f_show_err "$msg_invalid_virtual_device_type" \
493			   "$ZFSBOOT_VDEV_TYPE"
494		f_interactive || return $FAILURE
495	esac
496
497	# Calculate size of vdev menu once only
498	local vheight vwidth vrows
499	eval f_dialog_menu_with_help_size vheight vwidth vrows \
500		\"\$title\" \"\$btitle\" \"\$vdev_prompt\" \"\$vdev_hline\" \
501		$vdev_menu_list
502
503	# Get a list of probed disk devices
504	local disks=
505	debug= f_device_find "" $DEVICE_TYPE_DISK disks
506
507	# Prune out mounted md(4) devices that may be part of the boot process
508	local disk name new_list=
509	for disk in $disks; do
510		debug= $disk get name name
511		case "$name" in
512		md[0-9]*) f_mounted -b "/dev/$name" && continue ;;
513		esac
514		new_list="$new_list $disk"
515	done
516	disks="${new_list# }"
517
518	# Debugging
519	if [ "$debug" ]; then
520		local disk_names=
521		for disk in $disks; do
522			debug= $disk get name name
523			disk_names="$disk_names $name"
524		done
525		f_dprintf "$funcname: disks=[%s]" "${disk_names# }"
526	fi
527
528	if [ ! "$disks" ]; then
529		f_dprintf "No disk(s) present to configure"
530		f_show_err "$msg_no_disks_present_to_configure"
531		return $FAILURE
532	fi
533
534	# Lets sort the disks array to be more user friendly
535	f_device_sort_by name disks disks
536
537	#
538	# Operate in a loop so we can (if interactive) repeat if not enough
539	# disks are selected to satisfy the chosen vdev type or user wants to
540	# back-up to the previous menu.
541	#
542	local vardisk ndisks onoff selections vdev_choice breakout device
543	local valid_disks all_valid want_disks desc height width rows
544	while :; do
545		#
546		# Confirm the vdev type that was selected
547		#
548		if f_interactive && [ "$ZFSBOOT_CONFIRM_LAYOUT" ]; then
549			vdev_choice=$( eval $DIALOG \
550				--title \"\$title\"              \
551				--backtitle \"\$btitle\"         \
552				--hline \"\$vdev_hline\"         \
553				--ok-label \"\$msg_ok\"          \
554				--cancel-label \"\$msg_cancel\"  \
555				--item-help                      \
556				--default-item \"\$ZFSBOOT_VDEV_TYPE\" \
557				--menu \"\$vdev_prompt\"         \
558				$vheight $vwidth $vrows          \
559				$vdev_menu_list                  \
560				2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
561			) || return $?
562				# Exit if user pressed ESC or chose Cancel/No
563			f_dialog_data_sanitize vdev_choice
564
565			ZFSBOOT_VDEV_TYPE="$vdev_choice"
566			f_dprintf "$funcname: ZFSBOOT_VDEV_TYPE=[%s]" \
567			          "$ZFSBOOT_VDEV_TYPE"
568		fi
569
570		# Determine the number of disks needed for this vdev type
571		want_disks=0
572		case "$ZFSBOOT_VDEV_TYPE" in
573		stripe) want_disks=1 ;;
574		mirror) want_disks=2 ;;
575		raidz1) want_disks=3 ;;
576		raidz2) want_disks=4 ;;
577		raidz3) want_disks=5 ;;
578		esac
579
580		#
581		# Warn the user if any scripted disks are invalid
582		#
583		valid_disks= all_valid=${ZFSBOOT_DISKS:+1} # optimism
584		for disk in $ZFSBOOT_DISKS; do
585			if debug= f_device_find -1 \
586				$disk $DEVICE_TYPE_DISK device
587			then
588				valid_disks="$valid_disks $disk"
589				continue
590			fi
591			f_dprintf "$funcname: \`%s' is not a real disk" "$disk"
592			all_valid=
593		done
594		if [ ! "$all_valid" ]; then
595			if [ "$ZFSBOOT_DISKS" ]; then
596				f_show_err \
597				    "$msg_missing_one_or_more_scripted_disks"
598			else
599				f_dprintf "No disks selected."
600				f_interactive ||
601					f_show_err "$msg_no_disks_selected"
602			fi
603			f_interactive || return $FAILURE
604		fi
605		ZFSBOOT_DISKS="${valid_disks# }"
606
607		#
608		# Short-circuit if we're running non-interactively
609		#
610		if ! f_interactive || [ ! "$ZFSBOOT_CONFIRM_LAYOUT" ]; then
611			f_count ndisks $ZFSBOOT_DISKS
612			[ $ndisks -ge $want_disks ] && break # to success
613
614			# Not enough disks selected
615			f_dprintf "$funcname: %s: %s (%u < %u minimum)" \
616				  "$ZFSBOOT_VDEV_TYPE" \
617			          "Not enough disks selected." \
618				  $ndisks $want_disks
619			f_interactive || return $FAILURE
620			msg_yes="$msg_change_selection" msg_no="$msg_cancel" \
621				f_yesno "%s: $msg_not_enough_disks_selected" \
622				"$ZFSBOOT_VDEV_TYPE" $ndisks $want_disks ||
623				return $FAILURE
624		fi
625
626		#
627		# Confirm the disks that were selected
628		# Loop until the user cancels or selects enough disks
629		#
630		breakout=
631		while :; do
632			# Loop over list of available disks, resetting state
633			for disk in $disks; do
634				f_isset _${disk}_status && _${disk}_status=
635			done
636
637			# Loop over list of selected disks and create temporary
638			# locals to map statuses onto up-to-date list of disks
639			for disk in $ZFSBOOT_DISKS; do
640				debug= f_device_find -1 \
641					$disk $DEVICE_TYPE_DISK disk
642				f_isset _${disk}_status ||
643					local _${disk}_status
644				_${disk}_status=on
645			done
646
647			# Create the checklist menu of discovered disk devices
648			disk_check_list=
649			for disk in $disks; do
650				desc=
651				$disk get name name
652				$disk get desc desc
653				f_shell_escape "$desc" desc
654				f_getvar _${disk}_status:-off onoff
655				disk_check_list="$disk_check_list
656					$name '$desc' $onoff"
657			done
658
659			eval f_dialog_checklist_size height width rows \
660				\"\$title\" \"\$btitle\" \"\$prompt\" \
661				\"\$hline\" $disk_check_list
662
663			selections=$( eval $DIALOG \
664				--title \"\$DIALOG_TITLE\"         \
665				--backtitle \"\$DIALOG_BACKTITLE\" \
666				--separate-output                  \
667				--hline \"\$hline\"                \
668				--ok-label \"\$msg_ok\"            \
669				--cancel-label \"\$msg_back\"      \
670				--checklist \"\$prompt\"           \
671				$height $width $rows               \
672				$disk_check_list                   \
673				2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
674			) || break
675				# Loop if user pressed ESC or chose Cancel/No
676			f_dialog_data_sanitize selections
677
678			ZFSBOOT_DISKS="$selections"
679			f_dprintf "$funcname: ZFSBOOT_DISKS=[%s]" \
680			          "$ZFSBOOT_DISKS"
681
682			f_count ndisks $ZFSBOOT_DISKS
683			[ $ndisks -ge $want_disks ] &&
684				breakout=break && break
685
686			# Not enough disks selected
687			f_dprintf "$funcname: %s: %s (%u < %u minimum)" \
688				  "$ZFSBOOT_VDEV_TYPE" \
689			          "Not enough disks selected." \
690			          $ndisks $want_disks
691			msg_yes="$msg_change_selection" msg_no="$msg_cancel" \
692				f_yesno "%s: $msg_not_enough_disks_selected" \
693				"$ZFSBOOT_VDEV_TYPE" $ndisks $want_disks ||
694				break
695		done
696		[ "$breakout" = "break" ] && break
697		[ "$ZFSBOOT_CONFIRM_LAYOUT" ] || return $FAILURE
698	done
699
700	return $DIALOG_OK
701}
702
703# zfs_create_diskpart $disk $index
704#
705# For each block device to be used in the zpool, rather than just create the
706# zpool with the raw block devices (e.g., da0, da1, etc.) we create partitions
707# so we can have some real swap. This also provides wiggle room incase your
708# replacement drivers do not have the exact same sector counts.
709#
710# NOTE: $swapsize and $bootsize should be defined by the calling function.
711# NOTE: Sets $bootpart and $targetpart for the calling function.
712#
713zfs_create_diskpart()
714{
715	local funcname=zfs_create_diskpart
716	local disk="$1" index="$2"
717
718	# Check arguments
719	if [ ! "$disk" ]; then
720		f_dprintf "$funcname: NULL disk argument"
721		msg_error="$msg_error: $funcname" \
722			f_show_err "$msg_null_disk_argument"
723		return $FAILURE
724	fi
725	if [ "${disk#*[$IFS]}" != "$disk" ]; then
726		f_dprintf "$funcname: Invalid disk argument \`%s'" "$disk"
727		msg_error="$msg_error: $funcname" \
728			f_show_err "$msg_invalid_disk_argument" "$disk"
729		return $FAILURE
730	fi
731	if [ ! "$index" ]; then
732		f_dprintf "$funcname: NULL index argument"
733		msg_error="$msg_error: $funcname" \
734			f_show_err "$msg_null_index_argument"
735		return $FAILURE
736	fi
737	if ! f_isinteger "$index"; then
738		f_dprintf "$funcname: Invalid index argument \`%s'" "$index"
739		msg_error="$msg_error: $funcname" \
740			f_show_err "$msg_invalid_index_argument" "$index"
741		return $FAILURE
742	fi
743	f_dprintf "$funcname: disk=[%s] index=[%s]" "$disk" "$index"
744
745	# Check for unknown partition scheme before proceeding further
746	case "$ZFSBOOT_PARTITION_SCHEME" in
747	""|MBR|GPT*) : known good ;;
748	*)
749		f_dprintf "$funcname: %s is an unsupported partition scheme" \
750		          "$ZFSBOOT_PARTITION_SCHEME"
751		msg_error="$msg_error: $funcname" f_show_err \
752			"$msg_unsupported_partition_scheme" \
753			"$ZFSBOOT_PARTITION_SCHEME"
754		return $FAILURE
755	esac
756
757	#
758	# Enable boot pool if encryption is desired
759	#
760	[ "$ZFSBOOT_GELI_ENCRYPTION" ] && ZFSBOOT_BOOT_POOL=1
761
762	#
763	# ZFSBOOT_BOOT_POOL and BIOS+UEFI boot type are incompatible
764	#
765	if [ "$ZFSBOOT_BOOT_POOL" -a "$ZFSBOOT_BOOT_TYPE" = "BIOS+UEFI" ]; then
766		f_dprintf "$funcname: ZFSBOOT_BOOT_POOL is incompatible with BIOS+UEFI boot type"
767		msg_error="$msg_error: $funcname" f_show_err \
768			"ZFSBOOT_BOOT_POOL is incompatible with BIOS+UEFI boot type"
769		return $FAILURE
770	fi
771
772	#
773	# Destroy whatever partition layout is currently on disk.
774	# NOTE: `-F' required to destroy if partitions still exist.
775	# NOTE: Failure is ok here, blank disk will have nothing to destroy.
776	#
777	f_dprintf "$funcname: Destroying all data/layouts on \`%s'..." "$disk"
778	f_eval_catch -d $funcname gpart "$GPART_DESTROY_F" $disk
779	f_eval_catch -d $funcname graid "$GRAID_DELETE" $disk
780	f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" /dev/$disk
781
782	# Make doubly-sure backup GPT is destroyed
783	f_eval_catch -d $funcname gpart "$GPART_CREATE" gpt $disk
784	f_eval_catch -d $funcname gpart "$GPART_DESTROY_F" $disk
785
786	#
787	# Lay down the desired type of partition scheme
788	#
789	local setsize mbrindex align_small align_big
790	#
791	# If user has requested 4 K alignment, add these params to the
792	# gpart add calls. With GPT, we align large partitions to 1 M for
793	# improved performance on SSDs. MBR does not always play well with gaps
794	# between partitions, so all alignment is only 4k for that case.
795	# With MBR, we align the BSD partition that contains the MBR, otherwise
796	# the system fails to boot.
797	#
798	if [ "$ZFSBOOT_FORCE_4K_SECTORS" ]; then
799		align_small="-a 4k"
800		align_big="-a 1m"
801		sysctl kern.geom.part.mbr.enforce_chs=0
802	fi
803
804	case "$ZFSBOOT_PARTITION_SCHEME" in
805	""|GPT*) f_dprintf "$funcname: Creating GPT layout..."
806		#
807		# 1. Create GPT layout using labels
808		#
809		f_eval_catch $funcname gpart "$GPART_CREATE" gpt $disk ||
810		             return $FAILURE
811
812		#
813		# Apply workarounds if requested by the user
814		#
815		if [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT + Lenovo Fix" ]; then
816			f_eval_catch $funcname gpart "$GPART_SET_LENOVOFIX" \
817			             $disk || return $FAILURE
818		elif [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT + Active" ]; then
819			f_eval_catch $funcname gpart "$GPART_SET_PMBR_ACTIVE" \
820			             $disk || return $FAILURE
821		fi
822
823		#
824		# 2. Add small freebsd-boot or efi partition
825		#
826		if [ "$ZFSBOOT_BOOT_TYPE" = "UEFI" -o "$ZFSBOOT_BOOT_TYPE" = "BIOS+UEFI" ]; then
827			f_eval_catch $funcname gpart \
828			             "$GPART_ADD_ALIGN_LABEL_WITH_SIZE" \
829			             "$align_small" efiboot$index efi 800k $disk ||
830			             return $FAILURE
831			f_eval_catch $funcname gpart "$GPART_BOOTCODE_PARTONLY" \
832			             /boot/boot1.efifat 1 $disk ||
833			             return $FAILURE
834		fi
835
836		if [ "$ZFSBOOT_BOOT_TYPE" = "BIOS" -o "$ZFSBOOT_BOOT_TYPE" = "BIOS+UEFI" ]; then
837			f_eval_catch $funcname gpart \
838			             "$GPART_ADD_ALIGN_LABEL_WITH_SIZE" \
839			             "$align_small" gptboot$index freebsd-boot \
840			             512k $disk || return $FAILURE
841			if [ "$ZFSBOOT_BOOT_TYPE" = "BIOS" ]; then
842				f_eval_catch $funcname gpart "$GPART_BOOTCODE_PART" \
843				             /boot/pmbr /boot/gptzfsboot 1 $disk ||
844				             return $FAILURE
845			else
846				f_eval_catch $funcname gpart "$GPART_BOOTCODE_PART" \
847				             /boot/pmbr /boot/gptzfsboot 2 $disk ||
848				             return $FAILURE
849			fi
850		fi
851
852		# NB: zpool will use the `zfs#' GPT labels
853		if [ "$ZFSBOOT_BOOT_TYPE" = "BIOS+UEFI" ]; then
854			if [ "$ZFSBOOT_BOOT_POOL" ]; then
855				bootpart=p3 swappart=p4 targetpart=p4
856				[ ${swapsize:-0} -gt 0 ] && targetpart=p5
857			else
858				# Bootpart unused
859				bootpart=p3 swappart=p3 targetpart=p3
860				[ ${swapsize:-0} -gt 0 ] && targetpart=p4
861			fi
862		else
863			if [ "$ZFSBOOT_BOOT_POOL" ]; then
864				bootpart=p2 swappart=p3 targetpart=p3
865				[ ${swapsize:-0} -gt 0 ] && targetpart=p4
866			else
867				# Bootpart unused
868				bootpart=p2 swappart=p2 targetpart=p2
869				[ ${swapsize:-0} -gt 0 ] && targetpart=p3
870			fi
871		fi
872
873		#
874		# Prepare boot pool if enabled (e.g., for geli(8))
875		#
876		if [ "$ZFSBOOT_BOOT_POOL" ]; then
877			f_eval_catch $funcname gpart \
878			             "$GPART_ADD_ALIGN_LABEL_WITH_SIZE" \
879			             "$align_big" boot$index freebsd-zfs \
880			             ${bootsize}b $disk ||
881			             return $FAILURE
882			# Pedantically nuke any old labels
883			f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
884			                /dev/$disk$bootpart
885			if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
886				# Pedantically detach targetpart for later
887				f_eval_catch -d $funcname geli \
888				                "$GELI_DETACH_F" \
889				                /dev/$disk$targetpart
890			fi
891		fi
892
893		#
894		# 3. Add freebsd-swap partition labeled `swap#'
895		#
896		if [ ${swapsize:-0} -gt 0 ]; then
897			f_eval_catch $funcname gpart \
898			             "$GPART_ADD_ALIGN_LABEL_WITH_SIZE" \
899			             "$align_big" swap$index freebsd-swap \
900			             ${swapsize}b $disk ||
901			             return $FAILURE
902			# Pedantically nuke any old labels on the swap
903			f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
904			                /dev/$disk$swappart
905		fi
906
907		#
908		# 4. Add freebsd-zfs partition labeled `zfs#' for zroot
909		#
910		f_eval_catch $funcname gpart "$GPART_ADD_ALIGN_LABEL" \
911		             "$align_big" zfs$index freebsd-zfs $disk ||
912		             return $FAILURE
913		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
914		                /dev/$disk$targetpart
915		;;
916
917	MBR) f_dprintf "$funcname: Creating MBR layout..."
918		#
919		# 1. Create MBR layout (no labels)
920		#
921		f_eval_catch $funcname gpart "$GPART_CREATE" mbr $disk ||
922		             return $FAILURE
923		f_eval_catch $funcname gpart "$GPART_BOOTCODE" /boot/mbr \
924		             $disk || return $FAILURE
925
926		#
927		# 2. Add freebsd slice with all available space
928		#
929		f_eval_catch $funcname gpart "$GPART_ADD_ALIGN" "$align_small" \
930		             freebsd $disk ||
931		             return $FAILURE
932		f_eval_catch $funcname gpart "$GPART_SET_ACTIVE" 1 $disk ||
933		             return $FAILURE
934		# Pedantically nuke any old labels
935		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
936		                /dev/${disk}s1
937		# Pedantically nuke any old scheme
938		f_eval_catch -d $funcname gpart "$GPART_DESTROY_F" ${disk}s1
939
940		#
941		# 3. Write BSD scheme to the freebsd slice
942		#
943		f_eval_catch $funcname gpart "$GPART_CREATE" BSD ${disk}s1 ||
944		             return $FAILURE
945
946		# NB: zpool will use s1a (no labels)
947		bootpart=s1a swappart=s1b targetpart=s1d mbrindex=4
948
949		#
950		# Always prepare a boot pool on MBR
951		# Do not align this partition, there must not be a gap
952		#
953		ZFSBOOT_BOOT_POOL=1
954		f_eval_catch $funcname gpart \
955		             "$GPART_ADD_ALIGN_INDEX_WITH_SIZE" \
956		             "" 1 freebsd-zfs ${bootsize}b ${disk}s1 ||
957		             return $FAILURE
958		# Pedantically nuke any old labels
959		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
960		                /dev/$disk$bootpart
961		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
962			# Pedantically detach targetpart for later
963			f_eval_catch -d $funcname geli \
964			                "$GELI_DETACH_F" \
965					/dev/$disk$targetpart
966		fi
967
968		#
969		# 4. Add freebsd-swap partition
970		#
971		if [ ${swapsize:-0} -gt 0 ]; then
972			f_eval_catch $funcname gpart \
973			             "$GPART_ADD_ALIGN_INDEX_WITH_SIZE" \
974			             "$align_small" 2 freebsd-swap ${swapsize}b ${disk}s1 ||
975			             return $FAILURE
976			# Pedantically nuke any old labels on the swap
977			f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
978			                /dev/${disk}s1b
979		fi
980
981		#
982		# 5. Add freebsd-zfs partition for zroot
983		#
984		f_eval_catch $funcname gpart "$GPART_ADD_ALIGN_INDEX" \
985		             "$align_small" $mbrindex freebsd-zfs ${disk}s1 || return $FAILURE
986		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
987		                /dev/$disk$targetpart # Pedantic
988		f_eval_catch $funcname dd "$DD_WITH_OPTIONS" \
989		             /boot/zfsboot /dev/${disk}s1 count=1 ||
990		             return $FAILURE
991		;;
992
993	esac # $ZFSBOOT_PARTITION_SCHEME
994
995	# Update fstab(5)
996	local swapsize
997	f_expand_number "$ZFSBOOT_SWAP_SIZE" swapsize
998	if [ "$isswapmirror" ]; then
999		# This is not the first disk in the mirror, do nothing
1000	elif [ ${swapsize:-0} -eq 0 ]; then
1001		# If swap is 0 sized, don't add it to fstab
1002	elif [ "$ZFSBOOT_SWAP_ENCRYPTION" -a "$ZFSBOOT_SWAP_MIRROR" ]; then
1003		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1004		             /dev/mirror/swap.eli none swap sw 0 0 \
1005		             $BSDINSTALL_TMPETC/fstab ||
1006		             return $FAILURE
1007		isswapmirror=1
1008	elif [ "$ZFSBOOT_SWAP_MIRROR" ]; then
1009		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1010		             /dev/mirror/swap none swap sw 0 0 \
1011		             $BSDINSTALL_TMPETC/fstab ||
1012		             return $FAILURE
1013		isswapmirror=1
1014	elif [ "$ZFSBOOT_SWAP_ENCRYPTION" ]; then
1015		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1016		             /dev/$disk${swappart}.eli none swap sw 0 0 \
1017		             $BSDINSTALL_TMPETC/fstab ||
1018		             return $FAILURE
1019	else
1020		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1021		             /dev/$disk$swappart none swap sw 0 0 \
1022		             $BSDINSTALL_TMPETC/fstab ||
1023		             return $FAILURE
1024	fi
1025
1026	return $SUCCESS
1027}
1028
1029# zfs_create_boot $poolname $vdev_type $disks ...
1030#
1031# Creates boot pool and dataset layout. Returns error if something goes wrong.
1032# Errors are printed to stderr for collection and display.
1033#
1034zfs_create_boot()
1035{
1036	local funcname=zfs_create_boot
1037	local zroot_name="$1"
1038	local zroot_vdevtype="$2"
1039	local zroot_vdevs= # Calculated below
1040	local swap_devs= # Calculated below
1041	local boot_vdevs= # Used for geli(8) and/or MBR layouts
1042	shift 2 # poolname vdev_type
1043	local disks="$*" disk
1044	local isswapmirror
1045	local bootpart targetpart swappart # Set by zfs_create_diskpart() below
1046	local create_options
1047
1048	#
1049	# Pedantic checks; should never be seen
1050	#
1051	if [ ! "$zroot_name" ]; then
1052		f_dprintf "$funcname: NULL poolname"
1053		msg_error="$msg_error: $funcname" \
1054			f_show_err "$msg_null_poolname"
1055		return $FAILURE
1056	fi
1057	if [ $# -lt 1 ]; then
1058		f_dprintf "$funcname: missing disk arguments"
1059		msg_error="$msg_error: $funcname" \
1060			f_show_err "$msg_missing_disk_arguments"
1061		return $FAILURE
1062	fi
1063	f_dprintf "$funcname: poolname=[%s] vdev_type=[%s]" \
1064	          "$zroot_name" "$zroot_vdevtype"
1065
1066	#
1067	# Initialize fstab(5)
1068	#
1069	f_dprintf "$funcname: Initializing temporary fstab(5) file..."
1070	f_eval_catch $funcname sh "$SHELL_TRUNCATE" $BSDINSTALL_TMPETC/fstab ||
1071	             return $FAILURE
1072	f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1073	             "# Device" Mountpoint FStype Options Dump "Pass#" \
1074	             $BSDINSTALL_TMPETC/fstab || return $FAILURE
1075
1076	#
1077	# Expand SI units in desired sizes
1078	#
1079	f_dprintf "$funcname: Expanding supplied size values..."
1080	local swapsize bootsize
1081	if ! f_expand_number "$ZFSBOOT_SWAP_SIZE" swapsize; then
1082		f_dprintf "$funcname: Invalid swap size \`%s'" \
1083		          "$ZFSBOOT_SWAP_SIZE"
1084		f_show_err "$msg_invalid_swap_size" "$ZFSBOOT_SWAP_SIZE"
1085		return $FAILURE
1086	fi
1087	if ! f_expand_number "$ZFSBOOT_BOOT_POOL_SIZE" bootsize; then
1088		f_dprintf "$funcname: Invalid boot pool size \`%s'" \
1089		          "$ZFSBOOT_BOOT_POOL_SIZE"
1090		f_show_err "$msg_invalid_boot_pool_size" \
1091		           "$ZFSBOOT_BOOT_POOL_SIZE"
1092		return $FAILURE
1093	fi
1094	f_dprintf "$funcname: ZFSBOOT_SWAP_SIZE=[%s] swapsize=[%s]" \
1095	          "$ZFSBOOT_SWAP_SIZE" "$swapsize"
1096	f_dprintf "$funcname: ZFSBOOT_BOOT_POOL_SIZE=[%s] bootsize=[%s]" \
1097	          "$ZFSBOOT_BOOT_POOL_SIZE" "$bootsize"
1098
1099	#
1100	# Destroy the pool in-case this is our second time 'round (case of
1101	# failure and installer presented ``Retry'' option to come back).
1102	#
1103	# NB: If we don't destroy the pool, later gpart(8) destroy commands
1104	# that try to clear existing partitions (see zfs_create_diskpart())
1105	# will fail with a `Device Busy' error, leading to `GEOM exists'.
1106	#
1107	f_eval_catch -d $funcname zpool "$ZPOOL_DESTROY" "$zroot_name"
1108
1109	#
1110	# Prepare the disks and build pool device list(s)
1111	#
1112	f_dprintf "$funcname: Preparing disk partitions for ZFS pool..."
1113
1114	# Force 4K sectors using vfs.zfs.min_auto_ashift=12
1115	if [ "$ZFSBOOT_FORCE_4K_SECTORS" ]; then
1116		f_dprintf "$funcname: With 4K sectors..."
1117		f_eval_catch $funcname sysctl "$SYSCTL_ZFS_MIN_ASHIFT_12" \
1118		    || return $FAILURE
1119	fi
1120	local n=0
1121	for disk in $disks; do
1122		zfs_create_diskpart $disk $n || return $FAILURE
1123		# Now $bootpart, $targetpart, and $swappart are set (suffix
1124		# for $disk)
1125		if [ "$ZFSBOOT_BOOT_POOL" ]; then
1126			boot_vdevs="$boot_vdevs $disk$bootpart"
1127		fi
1128		zroot_vdevs="$zroot_vdevs $disk$targetpart"
1129		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1130			zroot_vdevs="$zroot_vdevs.eli"
1131		fi
1132
1133		n=$(( $n + 1 ))
1134	done # disks
1135
1136	#
1137	# If we need/want a boot pool, create it
1138	#
1139	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1140		local bootpool_vdevtype= # Calculated below
1141		local bootpool_options= # Calculated below
1142		local bootpool_name="$ZFSBOOT_BOOT_POOL_NAME"
1143		local bootpool="$BSDINSTALL_CHROOT/$bootpool_name"
1144		local zroot_key="${ZFSBOOT_GELI_KEY_FILE#/}"
1145
1146		f_dprintf "$funcname: Setting up boot pool..."
1147		[ "$ZFSBOOT_GELI_ENCRYPTION" ] &&
1148			f_dprintf "$funcname: For encrypted root disk..."
1149
1150		# Create parent directory for boot pool
1151		f_eval_catch -d $funcname umount "$UMOUNT" /mnt
1152		f_eval_catch $funcname mount "$MOUNT_TYPE" tmpfs none \
1153		             $BSDINSTALL_CHROOT || return $FAILURE
1154
1155		# Create mirror across the boot partition on all disks
1156		local nvdevs
1157		f_count nvdevs $boot_vdevs
1158		[ $nvdevs -gt 1 ] && bootpool_vdevtype=mirror
1159
1160		create_options="$ZFSBOOT_BOOT_POOL_CREATE_OPTIONS"
1161		bootpool_options="-o altroot=$BSDINSTALL_CHROOT"
1162		bootpool_options="$bootpool_options $create_options"
1163		bootpool_options="$bootpool_options -m \"/$bootpool_name\" -f"
1164		f_eval_catch $funcname zpool "$ZPOOL_CREATE_WITH_OPTIONS" \
1165		             "$bootpool_options" "$bootpool_name" \
1166		             "$bootpool_vdevtype" "$boot_vdevs" ||
1167		             return $FAILURE
1168
1169		f_eval_catch $funcname mkdir "$MKDIR_P" "$bootpool/boot" ||
1170		             return $FAILURE
1171
1172		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1173			# Generate an encryption key using random(4)
1174			f_eval_catch $funcname dd "$DD_WITH_OPTIONS" \
1175			             /dev/random "$bootpool/$zroot_key" \
1176			             "bs=4096 count=1" || return $FAILURE
1177			f_eval_catch $funcname chmod "$CHMOD_MODE" \
1178			             go-wrx "$bootpool/$zroot_key" ||
1179			             return $FAILURE
1180		else
1181			# Clean up
1182			f_eval_catch $funcname zfs "$ZFS_UNMOUNT" \
1183			             "$bootpool_name" || return $FAILURE
1184			f_eval_catch -d $funcname umount "$UMOUNT" /mnt # tmpfs
1185		fi
1186
1187	fi
1188
1189	#
1190	# Create the geli(8) GEOMS
1191	#
1192	if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1193		# Prompt user for password (twice)
1194		if ! msg_enter_new_password="$msg_geli_password" \
1195			f_dialog_input_password
1196		then
1197			f_dprintf "$funcname: User cancelled"
1198			f_show_err "$msg_user_cancelled"
1199			return $FAILURE
1200		fi
1201
1202		# Initialize geli(8) on each of the target partitions
1203		for disk in $disks; do
1204			f_dialog_info "$msg_geli_setup" \
1205				2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
1206			if ! echo "$pw_password" | f_eval_catch \
1207				$funcname geli "$GELI_PASSWORD_INIT" \
1208				"$bootpool/boot/$disk$targetpart.eli" \
1209				AES-XTS "$bootpool/$zroot_key" \
1210				$disk$targetpart
1211			then
1212				f_interactive || f_die
1213				unset pw_password # Sensitive info
1214				return $FAILURE
1215			fi
1216			if ! echo "$pw_password" | f_eval_catch \
1217				$funcname geli "$GELI_ATTACH" \
1218				"$bootpool/$zroot_key" $disk$targetpart
1219			then
1220				f_interactive || f_die
1221				unset pw_password # Sensitive info
1222				return $FAILURE
1223			fi
1224		done
1225		unset pw_password # Sensitive info
1226
1227		# Clean up
1228		f_eval_catch $funcname zfs "$ZFS_UNMOUNT" "$bootpool_name" ||
1229			return $FAILURE
1230		f_eval_catch -d $funcname umount "$UMOUNT" /mnt # tmpfs
1231	fi
1232
1233	#
1234	# Create the gmirror(8) GEOMS for swap
1235	#
1236	if [ "$ZFSBOOT_SWAP_MIRROR" ]; then
1237		for disk in $disks; do
1238			swap_devs="$swap_devs $disk$swappart"
1239		done
1240		f_eval_catch $funcname gmirror "$SWAP_GMIRROR_LABEL" \
1241			"$swap_devs" || return $FAILURE
1242	fi
1243
1244	#
1245	# Create the ZFS root pool with desired type and disk devices
1246	#
1247	f_dprintf "$funcname: Creating root pool..."
1248	create_options="$ZFSBOOT_POOL_CREATE_OPTIONS"
1249	f_eval_catch $funcname zpool "$ZPOOL_CREATE_WITH_OPTIONS" \
1250		"-o altroot=$BSDINSTALL_CHROOT $create_options -m none -f" \
1251		"$zroot_name" "$zroot_vdevtype" "$zroot_vdevs" ||
1252		return $FAILURE
1253
1254	#
1255	# Create ZFS dataset layout within the new root pool
1256	#
1257	f_dprintf "$funcname: Creating ZFS datasets..."
1258	echo "$ZFSBOOT_DATASETS" | while read dataset options; do
1259		# Skip blank lines and comments
1260		case "$dataset" in "#"*|"") continue; esac
1261		# Remove potential inline comments in options
1262		options="${options%%#*}"
1263		# Replace tabs with spaces
1264		f_replaceall "$options" "	" " " options
1265		# Reduce contiguous runs of space to one single space
1266		oldoptions=
1267		while [ "$oldoptions" != "$options" ]; do
1268			oldoptions="$options"
1269			f_replaceall "$options" "  " " " options
1270		done
1271		# Replace both commas and spaces with ` -o '
1272		f_replaceall "$options" "[ ,]" " -o " options
1273		# Create the dataset with desired options
1274		f_eval_catch $funcname zfs "$ZFS_CREATE_WITH_OPTIONS" \
1275		             "${options:+-o $options}" "$zroot_name$dataset" ||
1276		             return $FAILURE
1277	done
1278
1279	#
1280	# Set a mountpoint for the root of the pool so newly created datasets
1281	# have a mountpoint to inherit
1282	#
1283	f_dprintf "$funcname: Setting mountpoint for root of the pool..."
1284	f_eval_catch $funcname zfs "$ZFS_SET" \
1285		"mountpoint=/$zroot_name" "$zroot_name" ||
1286		return $FAILURE
1287
1288	# Touch up permissions on the tmp directories
1289	f_dprintf "$funcname: Modifying directory permissions..."
1290	local dir
1291	for dir in /tmp /var/tmp; do
1292		f_eval_catch $funcname mkdir "$MKDIR_P" \
1293		             $BSDINSTALL_CHROOT$dir || return $FAILURE
1294		f_eval_catch $funcname chmod "$CHMOD_MODE" 1777 \
1295		             $BSDINSTALL_CHROOT$dir || return $FAILURE
1296	done
1297
1298	# Create symlink(s)
1299	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1300		f_dprintf "$funcname: Creating /boot symlink for boot pool..."
1301		f_eval_catch $funcname ln "$LN_SF" "$bootpool_name/boot" \
1302		             $BSDINSTALL_CHROOT/boot || return $FAILURE
1303	fi
1304
1305	# Set bootfs property
1306	local zroot_bootfs="$ZFSBOOT_BEROOT_NAME/$ZFSBOOT_BOOTFS_NAME"
1307	f_dprintf "$funcname: Setting bootfs property..."
1308	f_eval_catch $funcname zpool "$ZPOOL_SET" \
1309		"bootfs=\"$zroot_name/$zroot_bootfs\"" "$zroot_name" ||
1310		return $FAILURE
1311
1312	# Export the pool(s)
1313	f_dprintf "$funcname: Temporarily exporting ZFS pool(s)..."
1314	f_eval_catch $funcname zpool "$ZPOOL_EXPORT" "$zroot_name" ||
1315	             return $FAILURE
1316	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1317		f_eval_catch $funcname zpool "$ZPOOL_EXPORT" \
1318		             "$bootpool_name" || return $FAILURE
1319	fi
1320
1321	# MBR boot loader touch-up
1322	if [ "$ZFSBOOT_PARTITION_SCHEME" = "MBR" ]; then
1323		f_dprintf "$funcname: Updating MBR boot loader on disks..."
1324		# Stick the ZFS boot loader in the "convienient hole" after
1325		# the ZFS internal metadata
1326		for disk in $disks; do
1327			f_eval_catch $funcname dd "$DD_WITH_OPTIONS" \
1328			             /boot/zfsboot /dev/$disk$bootpart \
1329			             "skip=1 seek=1024" || return $FAILURE
1330		done
1331	fi
1332
1333	# Re-import the ZFS pool(s)
1334	f_dprintf "$funcname: Re-importing ZFS pool(s)..."
1335	f_eval_catch $funcname zpool "$ZPOOL_IMPORT_WITH_OPTIONS" \
1336	             "-o altroot=\"$BSDINSTALL_CHROOT\"" "$zroot_name" ||
1337	             return $FAILURE
1338	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1339		f_eval_catch $funcname zpool "$ZPOOL_IMPORT_WITH_OPTIONS" \
1340		             "-o altroot=\"$BSDINSTALL_CHROOT\"" \
1341		             "$bootpool_name" || return $FAILURE
1342	fi
1343
1344	# While this is apparently not needed, it seems to help MBR
1345	f_dprintf "$funcname: Configuring zpool.cache for zroot..."
1346	f_eval_catch $funcname mkdir "$MKDIR_P" $BSDINSTALL_CHROOT/boot/zfs ||
1347	             return $FAILURE
1348	f_eval_catch $funcname zpool "$ZPOOL_SET" \
1349	             "cachefile=\"$BSDINSTALL_CHROOT/boot/zfs/zpool.cache\"" \
1350	             "$zroot_name" || return $FAILURE
1351
1352	# Last, but not least... required lines for rc.conf(5)/loader.conf(5)
1353	# NOTE: We later concatenate these into their destination
1354	f_dprintf "%s: Configuring rc.conf(5)/loader.conf(5) additions..." \
1355	          "$funcname"
1356	f_eval_catch $funcname echo "$ECHO_APPEND" 'zfs_enable=\"YES\"' \
1357	             $BSDINSTALL_TMPETC/rc.conf.zfs || return $FAILURE
1358	f_eval_catch $funcname echo "$ECHO_APPEND" \
1359	             'kern.geom.label.disk_ident.enable=\"0\"' \
1360	             $BSDINSTALL_TMPBOOT/loader.conf.zfs || return $FAILURE
1361	f_eval_catch $funcname echo "$ECHO_APPEND" \
1362	             'kern.geom.label.gptid.enable=\"0\"' \
1363	             $BSDINSTALL_TMPBOOT/loader.conf.zfs || return $FAILURE
1364
1365	if [ "$ZFSBOOT_SWAP_MIRROR" ]; then
1366		f_eval_catch $funcname echo "$ECHO_APPEND" \
1367		             'geom_mirror_load=\"YES\"' \
1368		             $BSDINSTALL_TMPBOOT/loader.conf.gmirror ||
1369		             return $FAILURE
1370	fi
1371
1372	# We're all done unless we should go on for boot pool
1373	[ "$ZFSBOOT_BOOT_POOL" ] || return $SUCCESS
1374
1375	# Set cachefile for boot pool so it auto-imports at system start
1376	f_dprintf "$funcname: Configuring zpool.cache for boot pool..."
1377	f_eval_catch $funcname zpool "$ZPOOL_SET" \
1378	             "cachefile=\"$BSDINSTALL_CHROOT/boot/zfs/zpool.cache\"" \
1379	             "$bootpool_name" || return $FAILURE
1380
1381	# Some additional geli(8) requirements for loader.conf(5)
1382	for option in \
1383		'zpool_cache_load=\"YES\"' \
1384		'zpool_cache_type=\"/boot/zfs/zpool.cache\"' \
1385		'zpool_cache_name=\"/boot/zfs/zpool.cache\"' \
1386	; do
1387		f_eval_catch $funcname echo "$ECHO_APPEND" "$option" \
1388		             $BSDINSTALL_TMPBOOT/loader.conf.zfs ||
1389		             return $FAILURE
1390	done
1391	f_eval_catch $funcname printf "$PRINTF_CONF" vfs.root.mountfrom \
1392		"\"zfs:$zroot_name/$zroot_bootfs\"" \
1393		$BSDINSTALL_TMPBOOT/loader.conf.root || return $FAILURE
1394
1395	# We're all done unless we should go on to do encryption
1396	[ "$ZFSBOOT_GELI_ENCRYPTION" ] || return $SUCCESS
1397
1398	#
1399	# Configure geli(8)-based encryption
1400	#
1401	f_dprintf "$funcname: Configuring disk encryption..."
1402	f_eval_catch $funcname echo "$ECHO_APPEND" 'aesni_load=\"YES\"' \
1403		$BSDINSTALL_TMPBOOT/loader.conf.aesni || return $FAILURE
1404	f_eval_catch $funcname echo "$ECHO_APPEND" 'geom_eli_load=\"YES\"' \
1405		$BSDINSTALL_TMPBOOT/loader.conf.geli || return $FAILURE
1406	f_eval_catch $funcname echo "$ECHO_APPEND" \
1407		'geom_eli_passphrase_prompt=\"YES\"' \
1408		$BSDINSTALL_TMPBOOT/loader.conf.geli || return $FAILURE
1409	for disk in $disks; do
1410		f_eval_catch $funcname printf "$PRINTF_CONF" \
1411			geli_%s_keyfile0_load "$disk$targetpart YES" \
1412			$BSDINSTALL_TMPBOOT/loader.conf.$disk$targetpart ||
1413			return $FAILURE
1414		f_eval_catch $funcname printf "$PRINTF_CONF" \
1415			geli_%s_keyfile0_type \
1416			"$disk$targetpart $disk$targetpart:geli_keyfile0" \
1417			$BSDINSTALL_TMPBOOT/loader.conf.$disk$targetpart ||
1418			return $FAILURE
1419		f_eval_catch $funcname printf "$PRINTF_CONF" \
1420			geli_%s_keyfile0_name \
1421			"$disk$targetpart \"$ZFSBOOT_GELI_KEY_FILE\"" \
1422			$BSDINSTALL_TMPBOOT/loader.conf.$disk$targetpart ||
1423			return $FAILURE
1424	done
1425
1426	return $SUCCESS
1427}
1428
1429# dialog_menu_diskinfo
1430#
1431# Prompt the user to select a disk and then provide detailed info on it.
1432#
1433dialog_menu_diskinfo()
1434{
1435	local device disk
1436
1437	#
1438	# Break from loop when user cancels disk selection
1439	#
1440	while :; do
1441		device=$( msg_cancel="$msg_back" f_device_menu \
1442			"$DIALOG_TITLE" "$msg_select_a_disk_device" "" \
1443			$DEVICE_TYPE_DISK 2>&1 ) || break
1444		$device get name disk
1445
1446		# Show gpart(8) `show' and camcontrol(8) `inquiry' data
1447		f_show_msg "$msg_detailed_disk_info" \
1448			"$disk" "$( gpart show $disk 2> /dev/null )" \
1449			"$disk" "$( camcontrol inquiry $disk 2> /dev/null )" \
1450			"$disk" "$( camcontrol identify $disk 2> /dev/null )"
1451	done
1452
1453	return $SUCCESS
1454}
1455
1456############################################################ MAIN
1457
1458#
1459# Initialize
1460#
1461f_dialog_title "$msg_zfs_configuration"
1462f_dialog_backtitle "$msg_freebsd_installer"
1463
1464# User may have specifically requested ZFS-related operations be interactive
1465! f_interactive && f_zfsinteractive && unset $VAR_NONINTERACTIVE
1466
1467#
1468# Debugging
1469#
1470f_dprintf "BSDINSTALL_CHROOT=[%s]" "$BSDINSTALL_CHROOT"
1471f_dprintf "BSDINSTALL_TMPETC=[%s]" "$BSDINSTALL_TMPETC"
1472f_dprintf "FSTAB_FMT=[%s]" "$FSTAB_FMT"
1473
1474#
1475# If the system was booted with UEFI, set the default boot type to UEFI
1476#
1477bootmethod=$( sysctl -n machdep.bootmethod )
1478f_dprintf "machdep.bootmethod=[%s]" "$bootmethod"
1479if [ "$bootmethod" = "UEFI" ]; then
1480	: ${ZFSBOOT_BOOT_TYPE:=BIOS+UEFI}
1481	: ${ZFSBOOT_PARTITION_SCHEME:=GPT}
1482else
1483	: ${ZFSBOOT_BOOT_TYPE:=BIOS}
1484	: ${ZFSBOOT_PARTITION_SCHEME:=GPT}
1485fi
1486
1487#
1488# Loop over the main menu until we've accomplished what we came here to do
1489#
1490while :; do
1491	if ! f_interactive; then
1492		retval=$DIALOG_OK
1493		mtag=">>> $msg_install"
1494	else
1495		dialog_menu_main
1496		retval=$?
1497		f_dialog_menutag_fetch mtag
1498	fi
1499
1500	f_dprintf "retval=%u mtag=[%s]" $retval "$mtag"
1501	[ $retval -eq $DIALOG_OK ] || f_die
1502
1503	case "$mtag" in
1504	">>> $msg_install")
1505		#
1506		# First, validate the user's selections
1507		#
1508
1509		# Make sure they gave us a name for the pool
1510		if [ ! "$ZFSBOOT_POOL_NAME" ]; then
1511			f_dprintf "Pool name cannot be empty."
1512			f_show_err "$msg_pool_name_cannot_be_empty"
1513			continue
1514		fi
1515
1516		# Validate vdev type against number of disks selected/scripted
1517		# (also validates that ZFSBOOT_DISKS are real [probed] disks)
1518		# NB: dialog_menu_layout supports running non-interactively
1519		dialog_menu_layout || continue
1520
1521		# Make sure each disk will have room for ZFS
1522		if f_expand_number "$ZFSBOOT_SWAP_SIZE" swapsize &&
1523		   f_expand_number "$ZFSBOOT_BOOT_POOL_SIZE" bootsize &&
1524		   f_expand_number "1g" zpoolmin
1525		then
1526			minsize=$(( $swapsize + $zpoolmin )) teeny_disks=
1527			[ "$ZFSBOOT_BOOT_POOL" ] &&
1528				minsize=$(( $minsize + $bootsize ))
1529			for disk in $ZFSBOOT_DISKS; do
1530				debug= f_device_find -1 \
1531					$disk $DEVICE_TYPE_DISK device
1532				$device get capacity disksize || continue
1533				[ ${disksize:-0} -ge 0 ] || disksize=0
1534				[ $disksize -lt $minsize ] &&
1535					teeny_disks="$teeny_disks $disk"
1536			done
1537			if [ "$teeny_disks" ]; then
1538				f_dprintf "swapsize=[%s] bootsize[%s] %s" \
1539				          "$ZFSBOOT_SWAP_SIZE" \
1540				          "$ZFSBOOT_BOOT_POOL_SIZE" \
1541				          "minsize=[$minsize]"
1542				f_dprintf "These disks are too small: %s" \
1543				          "$teeny_disks"
1544				f_show_err "$msg_these_disks_are_too_small" \
1545				           "$ZFSBOOT_SWAP_SIZE" \
1546				           "$ZFSBOOT_BOOT_POOL_SIZE" \
1547				           "$teeny_disks"
1548				continue
1549			fi
1550		fi
1551
1552		#
1553		# Last Chance!
1554		#
1555		if f_interactive; then
1556			dialog_last_chance $ZFSBOOT_DISKS || continue
1557		fi
1558
1559		#
1560		# Let's do this
1561		#
1562
1563		vdev_type="$ZFSBOOT_VDEV_TYPE"
1564
1565		# Blank the vdev type for the default layout
1566		[ "$vdev_type" = "stripe" ] && vdev_type=
1567
1568		zfs_create_boot "$ZFSBOOT_POOL_NAME" \
1569		                "$vdev_type" $ZFSBOOT_DISKS || continue
1570
1571		break # to success
1572		;;
1573	?" $msg_pool_type_disks")
1574		ZFSBOOT_CONFIRM_LAYOUT=1
1575		dialog_menu_layout
1576		# User has poked settings, disable later confirmation
1577		ZFSBOOT_CONFIRM_LAYOUT=
1578		;;
1579	"- $msg_rescan_devices") f_device_rescan ;;
1580	"- $msg_disk_info") dialog_menu_diskinfo ;;
1581	?" $msg_pool_name")
1582		# Prompt the user to input/change the name for the new pool
1583		f_dialog_input input \
1584			"$msg_please_enter_a_name_for_your_zpool" \
1585			"$ZFSBOOT_POOL_NAME" &&
1586			ZFSBOOT_POOL_NAME="$input"
1587		;;
1588	?" $msg_force_4k_sectors")
1589		# Toggle the variable referenced both by the menu and later
1590		if [ "$ZFSBOOT_FORCE_4K_SECTORS" ]; then
1591			ZFSBOOT_FORCE_4K_SECTORS=
1592		else
1593			ZFSBOOT_FORCE_4K_SECTORS=1
1594		fi
1595		;;
1596	?" $msg_encrypt_disks")
1597		# Toggle the variable referenced both by the menu and later
1598		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1599			ZFSBOOT_GELI_ENCRYPTION=
1600		else
1601			ZFSBOOT_FORCE_4K_SECTORS=1
1602			ZFSBOOT_GELI_ENCRYPTION=1
1603		fi
1604		;;
1605	?" $msg_partition_scheme")
1606		# Toggle between GPT (BIOS), GPT (UEFI) and MBR
1607		if [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT" -a "$ZFSBOOT_BOOT_TYPE" = "BIOS" ]; then
1608			ZFSBOOT_PARTITION_SCHEME="GPT"
1609			ZFSBOOT_BOOT_TYPE="UEFI"
1610		elif [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT" -a "$ZFSBOOT_BOOT_TYPE" = "UEFI" ]; then
1611			ZFSBOOT_PARTITION_SCHEME="GPT"
1612			ZFSBOOT_BOOT_TYPE="BIOS+UEFI"
1613		elif [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT" ]; then
1614			ZFSBOOT_PARTITION_SCHEME="MBR"
1615			ZFSBOOT_BOOT_TYPE="BIOS"
1616		elif [ "$ZFSBOOT_PARTITION_SCHEME" = "MBR" ]; then
1617			ZFSBOOT_PARTITION_SCHEME="GPT + Active"
1618			ZFSBOOT_BOOT_TYPE="BIOS"
1619		elif [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT + Active" ]; then
1620			ZFSBOOT_PARTITION_SCHEME="GPT + Lenovo Fix"
1621			ZFSBOOT_BOOT_TYPE="BIOS"
1622		else
1623			ZFSBOOT_PARTITION_SCHEME="GPT"
1624			ZFSBOOT_BOOT_TYPE="BIOS"
1625		fi
1626		;;
1627	?" $msg_swap_size")
1628		# Prompt the user to input/change the swap size for each disk
1629		while :; do
1630		    f_dialog_input input \
1631			    "$msg_please_enter_amount_of_swap_space" \
1632			    "$ZFSBOOT_SWAP_SIZE" &&
1633			    ZFSBOOT_SWAP_SIZE="${input:-0}"
1634		    if f_expand_number "$ZFSBOOT_SWAP_SIZE" swapsize
1635		    then
1636			if [ $swapsize -ne 0 -a $swapsize -lt 104857600 ]; then
1637			    f_show_err "$msg_swap_toosmall" \
1638				       "$ZFSBOOT_SWAP_SIZE"
1639			    continue;
1640			else
1641			    break;
1642			fi
1643		    else
1644			f_show_err "$msg_swap_invalid" \
1645				   "$ZFSBOOT_SWAP_SIZE"
1646			continue;
1647		    fi
1648		done
1649		;;
1650	?" $msg_swap_mirror")
1651		# Toggle the variable referenced both by the menu and later
1652		if [ "$ZFSBOOT_SWAP_MIRROR" ]; then
1653			ZFSBOOT_SWAP_MIRROR=
1654		else
1655			ZFSBOOT_SWAP_MIRROR=1
1656		fi
1657		;;
1658	?" $msg_swap_encrypt")
1659		# Toggle the variable referenced both by the menu and later
1660		if [ "$ZFSBOOT_SWAP_ENCRYPTION" ]; then
1661			ZFSBOOT_SWAP_ENCRYPTION=
1662		else
1663			ZFSBOOT_SWAP_ENCRYPTION=1
1664		fi
1665		;;
1666	esac
1667done
1668
1669exit $SUCCESS
1670
1671################################################################################
1672# END
1673################################################################################
1674